WildcardFileFilter (Commons IO 2.5)
Date: 2016-12-01

org.apache.commons.io.filefilter

## Class WildcardFileFilter

- java.lang.Object
- - org.apache.commons.io.filefilter.AbstractFileFilter
  - - org.apache.commons.io.filefilter.WildcardFileFilter

- All Implemented Interfaces:
    java.io.FileFilter, java.io.FilenameFilter, java.io.Serializable, IOFileFilter

      public class WildcardFileFilter
      extends AbstractFileFilter
      implements java.io.Serializable

  Filters files using the supplied wildcards.

  This filter selects files and directories based on one or more wildcards. Testing is case-sensitive by default, but this can be configured.

  The wildcard matcher uses the characters '?' and '*' to represent a single or multiple wildcard characters. This is the same as often found on Dos/Unix command lines. The check is case-sensitive by default. See `FilenameUtils.wildcardMatchOnSystem(java.lang.String, java.lang.String)` for more information.

  For example:

       File dir = new File(".");
       FileFilter fileFilter = new WildcardFileFilter("*test*.java~*~");
       File[] files = dir.listFiles(fileFilter);
       for (int i = 0; i < files.length; i++) {
         System.out.println(files[i]);
       }

  Since:
    1.3
  Version:
    $Id: WildcardFileFilter.java 1642757 2014-12-01 21:09:30Z sebb $
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private IOCase` | `caseSensitivity` Whether the comparison is case sensitive.
    `private static long` | `serialVersionUID`
    `private java.lang.String[]` | `wildcards` The wildcards that will be used to match filenames.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WildcardFileFilter(java.util.List<java.lang.String> wildcards)` Construct a new case-sensitive wildcard filter for a list of wildcards.
    `WildcardFileFilter(java.util.List<java.lang.String> wildcards, IOCase caseSensitivity)` Construct a new wildcard filter for a list of wildcards specifying case-sensitivity.
    `WildcardFileFilter(java.lang.String wildcard)` Construct a new case-sensitive wildcard filter for a single wildcard.
    `WildcardFileFilter(java.lang.String[] wildcards)` Construct a new case-sensitive wildcard filter for an array of wildcards.
    `WildcardFileFilter(java.lang.String[] wildcards, IOCase caseSensitivity)` Construct a new wildcard filter for an array of wildcards specifying case-sensitivity.
    `WildcardFileFilter(java.lang.String wildcard, IOCase caseSensitivity)` Construct a new wildcard filter for a single wildcard specifying case-sensitivity.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `accept(java.io.File file)` Checks to see if the filename matches one of the wildcards.
    `boolean` | `accept(java.io.File dir, java.lang.String name)` Checks to see if the filename matches one of the wildcards.
    `java.lang.String` | `toString()` Provide a String representation of this file filter.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### serialVersionUID

          private static final long serialVersionUID

      See Also:
        Constant Field Values

    - #### wildcards

          private final java.lang.String[] wildcards

      The wildcards that will be used to match filenames.

    - #### caseSensitivity

          private final IOCase caseSensitivity

      Whether the comparison is case sensitive.

  - ### Constructor Detail

    - #### WildcardFileFilter

          public WildcardFileFilter(java.lang.String wildcard)

      Construct a new case-sensitive wildcard filter for a single wildcard.
      Parameters:
        `wildcard` - the wildcard to match
      Throws:
        `java.lang.IllegalArgumentException` - if the pattern is null

    - #### WildcardFileFilter

          public WildcardFileFilter(java.lang.String wildcard,
                            IOCase caseSensitivity)

      Construct a new wildcard filter for a single wildcard specifying case-sensitivity.
      Parameters:
        `wildcard` - the wildcard to match, not null
        `caseSensitivity` - how to handle case sensitivity, null means case-sensitive
      Throws:
        `java.lang.IllegalArgumentException` - if the pattern is null

    - #### WildcardFileFilter

          public WildcardFileFilter(java.lang.String[] wildcards)

      Construct a new case-sensitive wildcard filter for an array of wildcards.

      Parameters:
        `wildcards` - the array of wildcards to match
      Throws:
        `java.lang.IllegalArgumentException` - if the pattern array is null

    - #### WildcardFileFilter

          public WildcardFileFilter(java.lang.String[] wildcards,
                            IOCase caseSensitivity)

      Construct a new wildcard filter for an array of wildcards specifying case-sensitivity.

      Parameters:
        `wildcards` - the array of wildcards to match, not null
        `caseSensitivity` - how to handle case sensitivity, null means case-sensitive
      Throws:
        `java.lang.IllegalArgumentException` - if the pattern array is null

    - #### WildcardFileFilter

          public WildcardFileFilter(java.util.List<java.lang.String> wildcards)

      Construct a new case-sensitive wildcard filter for a list of wildcards.
      Parameters:
        `wildcards` - the list of wildcards to match, not null
      Throws:
        `java.lang.IllegalArgumentException` - if the pattern list is null
        `java.lang.ClassCastException` - if the list does not contain Strings

    - #### WildcardFileFilter

          public WildcardFileFilter(java.util.List<java.lang.String> wildcards,
                            IOCase caseSensitivity)

      Construct a new wildcard filter for a list of wildcards specifying case-sensitivity.
      Parameters:
        `wildcards` - the list of wildcards to match, not null
        `caseSensitivity` - how to handle case sensitivity, null means case-sensitive
      Throws:
        `java.lang.IllegalArgumentException` - if the pattern list is null
        `java.lang.ClassCastException` - if the list does not contain Strings

  - ### Method Detail

    - #### accept

          public boolean accept(java.io.File dir,
                       java.lang.String name)

      Checks to see if the filename matches one of the wildcards.
      Specified by:
        `accept` in interface `java.io.FilenameFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Overrides:
        `accept` in class `AbstractFileFilter`
      Parameters:
        `dir` - the file directory (ignored)
        `name` - the filename
      Returns:
        true if the filename matches one of the wildcards

    - #### accept

          public boolean accept(java.io.File file)

      Checks to see if the filename matches one of the wildcards.
      Specified by:
        `accept` in interface `java.io.FileFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Overrides:
        `accept` in class `AbstractFileFilter`
      Parameters:
        `file` - the file to check
      Returns:
        true if the filename matches one of the wildcards

    - #### toString

          public java.lang.String toString()

      Provide a String representation of this file filter.
      Overrides:
        `toString` in class `AbstractFileFilter`
      Returns:
        a String representation

Copyright (c) 2002-2016 Apache Software Foundation